#include "stdafx.h"
#include "BitArray.h"
#include <memory.h>

byte CBitArray::GetBit(size_t bit_num)
{
	ASSERT(bit_num<all_bits);
	return (b_arr[bit_num>>3]>>(bit_num&7))&1;
}

void CBitArray::SetBit(size_t bit_num,byte bit_val)
{
	ASSERT(bit_num<all_bits);
	byte &B=b_arr[bit_num>>3];
	size_t b=bit_num&7;
	B &= ~(1<<b);
	B |= (bit_val&1)<<b;
}

CBitArray& CBitArray::operator= (CBitArray &arg)
{
	ASSERT(all_bytes==arg.all_bytes);
	memcpy(b_arr,arg.b_arr,all_bytes);
	return *this;
}

CBitArray::CBitArray(CBitArray &arg)
{
	all_bits=arg.all_bits;
	all_bytes=arg.all_bytes;
	last_bits=arg.last_bits;
	b_arr= new byte[all_bytes];
	operator=(arg);
}

CBitArray operator& (CBitArray &a,CBitArray &b)
{
	ASSERT(a.all_bytes==b.all_bytes);
	CBitArray ret(a.all_bits);
	DWORD dwNum=ret.all_bytes>>2;
	DWORD *pret= (DWORD*)ret.b_arr,
		  *pa= (DWORD*)a.b_arr, *pb= (DWORD*)b.b_arr;
	for(DWORD i=0;i<dwNum;i++)
		pret[i]=pa[i] & pb[i];
	for(i*=4;i<ret.all_bytes;i++)
		ret.b_arr[i]=a.b_arr[i] & b.b_arr[i];
	return ret;
}

CBitArray operator| (CBitArray &a,CBitArray &b)
{
	ASSERT(a.all_bytes==b.all_bytes);
	CBitArray ret(a.all_bits);
	DWORD dwNum=ret.all_bytes>>2;
	DWORD *pret= (DWORD*)ret.b_arr,
		  *pa= (DWORD*)a.b_arr, *pb= (DWORD*)b.b_arr;
	for(DWORD i=0;i<dwNum;i++)
		pret[i]=pa[i] | pb[i];
	for(i*=4;i<ret.all_bytes;i++)
		ret.b_arr[i]=a.b_arr[i] | b.b_arr[i];
	return ret;
}

CBitArray operator^ (CBitArray &a,CBitArray &b)
{
	ASSERT(a.all_bytes==b.all_bytes);
	CBitArray ret(a.all_bits);
	DWORD dwNum=ret.all_bytes>>2;
	DWORD *pret= (DWORD*)ret.b_arr,
		  *pa= (DWORD*)a.b_arr, *pb= (DWORD*)b.b_arr;
	for(DWORD i=0;i<dwNum;i++)
		pret[i]=pa[i] ^ pb[i];
	for(i*=4;i<ret.all_bytes;i++)
		ret.b_arr[i]=a.b_arr[i] ^ b.b_arr[i];
	return ret;
}

CBitArray operator~ (CBitArray &a)
{
	CBitArray ret(a.all_bits);
	DWORD dwNum=ret.all_bytes>>2;
	DWORD *pret= (DWORD*)ret.b_arr,
		  *pa= (DWORD*)a.b_arr;
	for(DWORD i=0;i<dwNum;i++)
		pret[i]= ~pa[i];
	for(i*=4;i<ret.all_bytes;i++)
		ret.b_arr[i]= ~a.b_arr[i];
	return ret;
}

int operator== (CBitArray &a,CBitArray &b)
{
	ASSERT(a.all_bits==b.all_bits);
	int ret=1;
	for(size_t i=0;i<a.all_bits && ret;i++)
		if(a.b_arr[i] != b.b_arr[i]) ret=0;
	return ret;
}

